#include <iostream>
using namespace std;

class person
{
private:
    char *name;
    int age;
public:
    person (const char *n, int a)
    {
        name = NULL;
        init (n, a);
    };
    ~person () { destroy (); };
    void init (const char*, int);
    void destroy ();
    void print () { cout << name << " " << age << endl; }
};

int main ()
{
    person p ("Liz", 19);
    p.print ();
    p.init ("Peter", 20);
    p.print ();
    return 0;
};

void person::destroy ()
{
    cout << "Deleting: " << name << endl;
    delete[] name;
};

void person::init (const char *n, int a)
{
    if (name != NULL) destroy ();
    name = new char[strlen(n)+1];
    strcpy (name, n);
    age = a;
}
