#include <iostream>
using namespace std;

class person;

void print_1 (const person&);
void print_2 (const person*);

struct person
{
    string name;
    int age;
    void print1 () const { print_1 (*this); };
    void print2 () const { print_2 (this); };
};

int main ()
{
    person p;
    p.name = "Liz";
    p.age = 19;
    p.print1 ();
    p.print2 ();
    return 0;
};

void print_1 (const person &p)
{
    cout << p.name << " " << p.age << endl;
};

void print_2 (const person *p)
{
    cout << p->name << " " << p->age << endl;
}
