#include <iostream>
using namespace std;

class person
{
protected:    
    string name;
    int age;
public:
    person (const string&, int);
    ~person ();
    void print ();
};

class student:public person
{
    int semester;
public:    
    student (const string&, int, int);
    ~student ();
    void print ();
};

int main ()
{
    person p ("Liz", 19);
    p.print ();
    student s ("Peter", 20, 4);
    s.print ();
    return 0;
};

person::person (const string &n, int a)
{
    name = n;
    age = a;
};

void person::print ()
{
    cout << name << " " << age << endl;
};    

person::~person ()
{
    cout << "PERSON " << name << " DELETED" << endl;
};    

student::student (const string &n, int a, int s):person (n, a)
{
    semester = s;
};

void student::print ()
{
    cout << name << " " << age << " " << semester << endl;
};    

student::~student ()
{
    cout << "STUDENT " << name << " DELETED" << endl;
}  
