#include <iostream>
using namespace std;

class person
{
protected:    
    string name;
    int age;
public:
    person (const string&, int);
    virtual ~person ();
    virtual void print ();
};

class student:public person
{
    int semester;
public:    
    student (const string&, int, int);
    ~student ();
    void print ();
};

int main ()
{
    person* pp[2];
    pp[0] = new person ("Liz", 19);
    pp[1] = new student ("Peter", 20, 4);
    for (int i=0; i<2; i++) pp[i]->print ();
    for (int i=0; i<2; i++) delete pp[i];
    return 0;
};

person::person (const string &n, int a)
{
    name = n;
    age = a;
};

void person::print ()
{
    cout << name << " " << age << endl;
};    

person::~person ()
{
    cout << "PERSON " << name << " DELETED" << endl;
};    

student::student (const string &n, int a, int s):person (n, a)
{
    semester = s;
};

void student::print ()
{
    cout << name << " " << age << " " << semester << endl;
};    

student::~student ()
{
    cout << "STUDENT " << name << " DELETED" << endl;
}  
