#include <iostream>
using namespace std;

class integer
{
    int value;
public:
    integer (int i) { value = i; };
    integer () {};
    integer operator+ (const integer&);
    friend integer& operator+= (integer&, const integer&);
    friend ostream &operator<< (ostream&, const integer&);
};

int main ()
{
    integer i(5);
    integer j(2);
    j += i;
    integer k;
    k = i + j;
    cout << i << endl;
    cout << j << endl;
    cout << k << endl;
    return 0;
};

integer &operator+= (integer &i, const integer &k)
{
    i.value += k.value;
    return i;
};

ostream &operator<< (ostream &out, const integer &i)
{
    out << i.value;
};

integer integer::operator+ (const integer &i)
{
    integer ret(value);
    ret.value += i.value;
    return ret;
}
